#pragma once

#include <iostream>
#include <fstream>

using namespace System;
using namespace System::Collections;
using namespace System::ServiceProcess;
using namespace System::ComponentModel;


namespace BatteryMonService
{
	std::ofstream logFile;
	HINSTANCE	hPowrProf;
	LONG		(WINAPI *pfnCallNtPowerInformation)(POWER_INFORMATION_LEVEL, PVOID, ULONG, PVOID, ULONG);

	/// <summary> 
	/// Summary for BatteryMonServiceWinService
	/// </summary>
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	public __gc class BatteryMonServiceWinService : public System::ServiceProcess::ServiceBase 
	{
	public:
		BatteryMonServiceWinService()
		{
			InitializeComponent();    
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		void Dispose(bool disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
		
	protected:

		/// <summary>
		/// Set things in motion so your service can do its work.
		/// </summary>
		void OnStart(String* args[])
		{
			if ( ( hPowrProf = LoadLibrary( _T("PowrProf.dll") ) ) != NULL )
			{
				(FARPROC&)pfnCallNtPowerInformation = GetProcAddress( hPowrProf, "CallNtPowerInformation" );
				logFile.open( "C:\\battery\\log.txt", std::ios::app );
			}
			else
			{
				pfnCallNtPowerInformation = NULL;
			}
		}
		
		/// <summary>
		/// Stop this service.
		/// </summary>
		void OnStop()
		{     
			logFile.close();
			if ( hPowrProf != NULL) FreeLibrary( hPowrProf );
		}
	private: System::Timers::Timer *  recordTimer;


	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container *components;

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>	
		void InitializeComponent(void)
		{
			this->recordTimer = new System::Timers::Timer();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->recordTimer))->BeginInit();
			// 
			// recordTimer
			// 
			this->recordTimer->Enabled = true;
			this->recordTimer->Interval = 60000;
			this->recordTimer->Elapsed += new System::Timers::ElapsedEventHandler(this, timer1_Elapsed);
			// 
			// BatteryMonServiceWinService
			// 
			this->CanPauseAndContinue = true;
			this->ServiceName = S"BatteryMonServiceWinService";
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->recordTimer))->EndInit();

		}		
	private: System::Void timer1_Elapsed(System::Object *  sender, System::Timers::ElapsedEventArgs *  e)
			 {
				 if ( logFile.is_open() && pfnCallNtPowerInformation != NULL )
				 {
					SYSTEMTIME now;
					GetSystemTime( &now );
					char* time = new char[4+2+2+2+2+2+1];
					sprintf(time, "%04d%02d%02d%02d%02d%02d", 
						now.wYear, now.wMonth, now.wDay, now.wHour, now.wMinute, now.wSecond );
					logFile << time << ", ";
					delete time;

					SYSTEM_BATTERY_STATE SystemBS;
					pfnCallNtPowerInformation( SystemBatteryState, 0, 0, &SystemBS, sizeof(SYSTEM_BATTERY_STATE) );
					logFile << ( SystemBS.AcOnLine ? "true" : "false" ) << ", ";
					logFile << ( SystemBS.BatteryPresent ? "true" : "false" ) << ", ";
					logFile << ( SystemBS.Charging ? "true" : "false" ) << ", ";
					logFile << ( SystemBS.Discharging ? "true" : "false" ) << ", ";
					logFile << SystemBS.MaxCapacity << ", ";
					logFile << SystemBS.RemainingCapacity << ", ";
					logFile << (LONG) SystemBS.Rate << ", ";
					logFile << SystemBS.EstimatedTime << std::endl;
				 }
			 }

	};
}